SystemOrganization addCategory: 'OrbeonBPMRuntime_Tests'!

TestCase subclass: #BpmProcessExecutionTest
	instanceVariableNames: 'procInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/20/2015 13:30'!
createFormInstance: xmlMethodName definitionNamed: definitionName app: app
	"The receiver create anOrbeonFormInstance of form definition named <definitionName> of Orbeon Applicaiton named <app> using the method <xmlMethodName> to get the XML string of the form "
	| application definition |

	application := OrbeonApplication applicationNamed: app.
	definition := application definitionNamed: definitionName.

	^(OrbeonFormInstance app: app form: definitionName id: UUID new asString)
			definition: definition;
			xmlString: (OrbeonFormTemplate perform: xmlMethodName);
			processXML;
			yourself! !

!BpmProcessExecutionTest methodsFor: 'Accessing' stamp: 'BrunoBB 11/17/2015 11:34'!
procInstance
	^procInstance! !

!BpmProcessExecutionTest methodsFor: 'Updating' stamp: 'BrunoBB 11/17/2015 11:34'!
procInstance: newValue
	procInstance := newValue! !

BpmProcessExecutionTest subclass: #SmaltalksRegistrationExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/22/2015 17:14'!
finalizeRegistrationForm
	| registrationForm currentTask nextTasks |

	registrationForm := self formInstance_registration.

	currentTask := procInstance currentActivities last.
	currentTask formInstance: registrationForm.

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:03'!
formInstance_acceptRegistration

	^self createFormInstance: #form_acceptRegistration definitionNamed: 'accept-registration' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:02'!
formInstance_analyzeData1

	^self createFormInstance: #form_analyzeData1 definitionNamed: 'analyze-data' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:02'!
formInstance_analyzeData2

	^self createFormInstance: #form_analyzeData2 definitionNamed: 'analyze-data' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 11:56'!
formInstance_registration

	^self createFormInstance: #form_registration definitionNamed: 'registration' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:04'!
formInstance_securityReport

	^self createFormInstance: #form_securityReport definitionNamed: 'security-report' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/22/2015 17:01'!
setUp
	| procDefinition processGenerator |

	processGenerator := BpmProcessGenerator exampleSmalltalksRegistration.

	procDefinition := processGenerator getProcessDefinitionNamed: 'registration' ifNone: [self assert: false].

	procInstance := procDefinition createProcessInstance: (BpmUser getUserNamed: 'alberto').

	procDefinition addProcessInstance: procInstance.

	procInstance triggerStartEvent.! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/17/2015 12:01'!
tearDown

	procInstance definition removeProcessInstance: procInstance! !
